//https://www.msx.org/forum/development/msx-development/undocumented-mode-1-2-polldiscussion

#include <stdio.h>
#include <windows.h>   
#include "vsm.hpp"   

/********************************************************************/

class PR5C01A : public IACTIVEMODEL,public IDSIMMODEL 
{ 
public: 
  int isdigital (CHAR *pinname); 
  void setup (IINSTANCE *inst, IDSIMCKT *dsim); 
  void runctrl (RUNMODES mode); 
  void actuate (REALTIME time, ACTIVESTATE newstate); 
  BOOL indicate (REALTIME time, ACTIVEDATA *data); 
  void simulate (ABSTIME time, DSIMMODES mode); 
  void callback (ABSTIME time, EVENTID eventid); 
  void initialize (ICOMPONENT *cpt); 
  ISPICEMODEL *getspicemodel (CHAR *device); 
  IDSIMMODEL *getdsimmodel (CHAR *device); 
  void plot (ACTIVESTATE state); 
  void animate (INT element, ACTIVEDATA *newstate); 
  BOOL actuate (WORD key, INT x, INT y, DWORD flags); 
  unsigned char takt;
  unsigned char RegD,RegF,Reg0[16],Reg1[16];

private: 
 unsigned char get_data();
 void set_data(ABSTIME time,unsigned char tmp);
 void set_data_Z(ABSTIME time);
 void Process_command(void);
  IINSTANCE *instance;  
  IDSIMCKT *ckt;      
  ICOMPONENT *component;   
  IDSIMPIN *pin_A0; 
  IDSIMPIN *pin_A1; 
  IDSIMPIN *pin_A2; 
  IDSIMPIN *pin_A3; 
  IDSIMPIN *pin_D0; 
  IDSIMPIN *pin_D1; 
  IDSIMPIN *pin_D2; 
  IDSIMPIN *pin_D3; 
  IDSIMPIN *pin_nCS1; 
  IDSIMPIN *pin_nRD; 
  IDSIMPIN *pin_nWR; 

}; 

HANDLE hProcessHeap;

extern "C" IDSIMMODEL __declspec(dllexport)*createdsimmodel(CHAR *device,ILICENCESERVER *ils)   {     
        ils->authorize(0x88888888, 0x69);  
        return new PR5C01A;   
}   

extern "C" VOID __declspec(dllexport)deletedsimmodel(IDSIMMODEL*model)   {   
    delete (PR5C01A*)model; 
}   
       
int PR5C01A::isdigital(CHAR *pinname)   {   
        return 1;   
}   

/********************************************************************/

void PR5C01A::setup(IINSTANCE *inst,IDSIMCKT *dsim)   {   
    instance = inst;    
          ckt = dsim;     
CFile f;
CFileException e;
        
    instance->log("PR5C01A.dll - Version 1");
    hProcessHeap=GetProcessHeap();
  RegD=0x0a;
  Reg[9]=0;

    pin_nCS1 = instance->getdsimpin("$CS1$", true); pin_nCS1->setstate(0,1,FLT);
    pin_nRD = instance->getdsimpin("$RD$", true); pin_nRD->setstate(0,1,FLT);
    pin_nWR = instance->getdsimpin("$WR$", true); pin_nWR->setstate(0,1,FLT);
    pin_D0 = instance->getdsimpin("D0", true);
    pin_D1 = instance->getdsimpin("D1", true);
    pin_D2 = instance->getdsimpin("D2", true);
    pin_D3 = instance->getdsimpin("D3", true);    set_data_Z(0);
    pin_D4 = instance->getdsimpin("A0", true);
    pin_D5 = instance->getdsimpin("A1", true);
    pin_D6 = instance->getdsimpin("A2", true);
    pin_D7 = instance->getdsimpin("A3", true);    

TCHAR* pszFileName = _T("Open_File.dat");
if(!f.Open(pszFileName, CFile::modeCreate | CFile::modeWrite, &e))
{
//   TRACE(_T("File could not be opened %d\n"), e.m_cause);
}

}   
       
void PR5C01A::runctrl(RUNMODES mode)  {   

}   
       
       
void PR5C01A::actuate(REALTIME time,ACTIVESTATE newstate) {   

}   
       
BOOL PR5C01A::indicate(REALTIME time,ACTIVEDATA *data)   {      
  return TRUE;
}   
//    Z       
void PR5C01A::set_data_Z(ABSTIME time)
{
 pin_D0->setstate(time,1,FLT);   
 pin_D1->setstate(time,1,FLT);   
 pin_D2->setstate(time,1,FLT);   
 pin_D3->setstate(time,1,FLT);   
}
//    
unsigned char PR5C01A::get_data()
{
unsigned char tmp=0;
 if (ishigh(pin_D0->istate())) tmp|=0x01;
 if (ishigh(pin_D1->istate())) tmp|=0x02;
 if (ishigh(pin_D2->istate())) tmp|=0x04;
 if (ishigh(pin_D3->istate())) tmp|=0x08;
 return tmp;
}
//   
void PR5C01A::set_data(ABSTIME time,unsigned char tmp)
{
  if (tmp&0x01) pin_D0->setstate(time,1,SHI); else pin_D0->setstate(time,1,SLO);
  if (tmp&0x02) pin_D1->setstate(time,1,SHI); else pin_D1->setstate(time,1,SLO);
  if (tmp&0x04) pin_D2->setstate(time,1,SHI); else pin_D2->setstate(time,1,SLO);
  if (tmp&0x08) pin_D3->setstate(time,1,SHI); else pin_D3->setstate(time,1,SLO);
}

//   
void PR5C01A::simulate (ABSTIME time,DSIMMODES mode) {      
unsigned char tmp,tmp1;
tmp=0;
 if (ishigh(pin_A0->istate())) tmp|=0x01;
 if (ishigh(pin_A1->istate())) tmp|=0x02;
 if (ishigh(pin_A2->istate())) tmp|=0x04;
 if (ishigh(pin_A3->istate())) tmp|=0x08;

 if (pin_nRD->isnegedge()) 
 {
  if (tmp<0x0d) { if ((RegD&0x03)==0x03) tmp1=Reg1[tmp]); else set_data(time,Reg0[tmp]);}
   else {if (tmp==0x0d) set_data(time,RegD); else set_data(time,RegF);}
  set_data(time,tmp1);
instance->log("rtc read reg[%x]-%x",tmp, tmp1); 
 }
 if (pin_nRD->isposedge()) set_data_Z(time);

if (pin_nWR->isposedge())
  {
  tmp1=get_data();
  if (tmp<0x0d) { if ((RegD&0x03)==0x03) Reg1[tmp]=tmp1; else Reg0[tmp]=tmp1;}
   else {if (tmp==0x0d) RegD=tmp1; else {if (tmp==0x0f) RegF=tmp1;}}
instance->log("rtc write reg[%x]=%x",tmp, tmp1); 
  }
}   
       
      
void PR5C01A::callback(ABSTIME time,EVENTID eventid)   {   

}   
              
extern "C" IACTIVEMODEL __declspec(dllexport)*createactivemodel(CHAR *device,ILICENCESERVER *ils)  {    
        ils->authorize (0);     
        return new PR5C01A;
}   
              
extern "C" VOID  __declspec(dllexport)deleteactivemodel (IACTIVEMODEL *model)  {    
  delete (PR5C01A*)model;   
}   
               
void PR5C01A::initialize(ICOMPONENT *cpt)  {    

}   
               
ISPICEMODEL *PR5C01A::getspicemodel(CHAR *)  {    
        return NULL;    
}   
       
IDSIMMODEL  *PR5C01A::getdsimmodel(CHAR *)  {      
        return this;    
}   

void PR5C01A::plot(ACTIVESTATE state)  {   

//  MessageBox(0, "plot", "Break", MB_OK);
}
        
void PR5C01A::animate(INT element, ACTIVEDATA *data)  {    
//  MessageBox(0, "animate", "Break", MB_OK);

}   

BOOL PR5C01A::actuate(WORD key, INT x, INT y, DWORD flags)  {
//  MessageBox(0, "ACTUATE2", "Break", MB_OK);
        return FALSE;    
}  
